/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomXSLTProcessor_H__
#define __GdomXSLTProcessor_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomXSLTProcessor GdomXSLTProcessor;
typedef struct _GdomXSLTProcessorClass GdomXSLTProcessorClass;


#define GDOM_TYPE_XSLT_PROCESSOR            (gdom_xslt_processor_get_type())
#define GDOM_XSLT_PROCESSOR(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_XSLT_PROCESSOR, GdomXSLTProcessor))
#define GDOM_XSLT_PROCESSOR_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_XSLT_PROCESSOR, GdomXSLTProcessor)Class)
#define GDOM_IS_XSLT_PROCESSOR(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_XSLT_PROCESSOR))
#define GDOM_IS_XSLT_PROCESSOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_XSLT_PROCESSOR))
#define GDOM_XSLT_PROCESSOR_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_XSLT_PROCESSOR, GdomXSLTProcessorClass))

typedef struct _GdomXSLTProcessorPrivate GdomXSLTProcessorPrivate;

struct _GdomXSLTProcessor {
    GdomDOMObject parent_instance;
    GdomXSLTProcessorPrivate *priv;
};

struct _GdomXSLTProcessorClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_xslt_processor_get_type (void);


/* XXX TODO: custom function gdom_xslt_processor_import_stylesheet */


/* XXX TODO: custom function gdom_xslt_processor_transform_to_fragment */


/* XXX TODO: custom function gdom_xslt_processor_transform_to_document */


/* XXX TODO: custom function gdom_xslt_processor_set_parameter */


/* XXX TODO: custom function gdom_xslt_processor_get_parameter */


/* XXX TODO: custom function gdom_xslt_processor_remove_parameter */

WEBKIT_API void
gdom_xslt_processor_clear_parameters (GdomXSLTProcessor *thiz);

WEBKIT_API void
gdom_xslt_processor_reset (GdomXSLTProcessor *thiz);

G_END_DECLS

#endif /* __GdomXSLTProcessor_H__ */
